/*
  The infopipe configuration parameters. These are read from
  XMMS configuration file to the InfoPipeConf structure using
  load_config() in infopipe_config.c.

  $Id: infopipe_config.h,v 1.2 2002/05/19 10:56:42 wwwwolf Exp $
 */

#ifndef INFOPIPE_PLUGIN_CONFIG_H
#define INFOPIPE_PLUGIN_CONFIG_H

#include <glib.h>

/* Configuration parameters */
typedef struct {
  gboolean create_symlinks;     /* Create legacy symlink on startup? */
  gboolean delete_symlinks;     /* Delete legacy symlink on exit? */
  gboolean do_chown;            /* Do we want to chown() for someone? */
  gint chowntouid;              /* uid to chown to */
  gint chowntogid;              /* gid to chown to */
} InfoPipeConf;

extern InfoPipeConf param;

#endif /* INFOPIPE_PLUGIN_CONFIG_H */
